// Falls Menue hoeher als Seite, mitscrollen lassen
function DoubleScroll (_el) { with (this) {
 var el = _el;
 var pel = el.parentElement;
 var lastY = window.pageYOffset;
 var top = el.offsetTop
 var scroll = function () {
  y = window.pageYOffset;
  top += lastY - y;
  if (top < pel.offsetHeight - el.offsetHeight) top = pel.offsetHeight - el.offsetHeight;
  if (top > 0) top = 0;
  el.style.top = top + 'px';
  lastY = y;
 }
 document.addEventListener('scroll', scroll, false);
} }

// automatisches ein/ausklappen
function AutoFlapout (_el) { with (this) {
 var rootEl = _el;
 var activeTree = new Array();

 this.autoFlapIn = true;
 this.duration = 500;

 this.flapOut = function (el) {
  if (!el.flappedIn) return;
  el.flappedIn = false;
  if (!el.effect) { el.style.height = 'auto'; return; }
  el.style.height = 'auto';
  el.effect.maxHeight = el.offsetHeight;
  el.style.height = '0px';
  el.effect.startTime = getTickCount();
  if (!el.effect.timer) el.effect.timer = window.setInterval(effect, 40, el);
 }

 this.flapIn = function (el, noEffect) {
  if (el.flappedIn || el == rootEl) return;
  el.flappedIn = true;
  el.style.overflow = 'hidden';
  if (noEffect) {
   el.style.height = '0px';
   if (el.effect && el.effect.timer) window.clearInterval(el.effect.timer);
   return;
  }
  el.style.height = 'auto';
  if (!el.effect) el.effect = new Object();
  el.effect.maxHeight = el.offsetHeight;
  el.effect.startTime = getTickCount();
  if (!el.effect.timer) el.effect.timer = window.setInterval(effect, 40, el);
 }

 var effect = function (el) {
  if (!el.effect) throw 'Effect Timer wurde nicht beendet!';
  var t = getTickCount();
  if (t > el.effect.startTime + duration) {
   if (!el.flappedIn) el.style.height = 'auto';
   else el.style.height = '0px';
   window.clearInterval(el.effect.timer);
   el.effect.timer = null;
  } else {
   var s = (t - el.effect.startTime) / duration;
   if (el.flappedIn) s = 1 - s;
    el.style.height = (el.effect.maxHeight * s) + 'px';
  }
 }

 this.activeTreeFrom = function (activeEl) {
  activeTree = new Array();
  var el = activeEl;
  while (el && el.tagName.toLowerCase() != 'li' && el.tagName.toLowerCase() != 'ol' && el.parentElement) el = el.parentElement;
  if (el && el.tagName.toLowerCase() == 'li') {
   var i = 0;
   var f = false;
   while (i < el.parentElement.childNodes.length) {
    if (f && el.parentElement.childNodes[i].nodeType == 1) {
     if (el.parentElement.childNodes[i].tagName.toLowerCase() == 'ol') el = el.parentElement.childNodes[i];
     break;
    }
    if (el.parentElement.childNodes[i] == el) f = true;
    i++;
   }
   if (el.tagName.toLowerCase() == 'li') el = el.parentElement;
  }
  while (el) {
   activeTree.unshift(el);
   flapOut(el);
   if (el == rootEl) break;
   el = el.parentElement;
  }
  if (autoFlapIn) flapAllIn();
 }

 this.flapAllIn = function (el, noEffect) {
  if (!el) el = rootEl;
  var f = false;
  for (var i = 0; i < activeTree.length; i++) if (activeTree[i] == el) {
   if (i == activeTree.length - 1) return;
   f = true;
   break;
  }
  if (!f) flapIn(el, noEffect);
  for (var i = 0; i < el.getElementsByTagName('ol').length; i++) flapAllIn(el.getElementsByTagName('ol')[i]);
 }

 this.flapAllOut = function (el) {
  if (!el) el = rootEl;
  flapOut(el);
  for (var i = 0; i < el.getElementsByTagName('ol').length; i++) flapAllOut(el.getElementsByTagName('ol')[i]);
 }
} }

// Menue kopieren
function toFormatedCode (el, hirachy) {
 function uml (s) {
  s = s.split('');
  for (var i = 0; i < s.length; i++) {
   var c = s[i].charCodeAt(0);
   if (c == 46 || c == 32 || (c >= 48 && c <= 57) || (c >= 65 && c <= 90) || (c >= 97 && c <= 122)) continue;
   s[i] = '&amp;#' + c + ';';
   }
  return s.join('');
 }
 function unformat (v) {
  var i = 0;
  var j = v.length;
  while (i < v.length && (v.charCodeAt(i) == 10 || v.charCodeAt(i) == 13)) i++;
  while (j > i && (v.charCodeAt(j-1) == 10 || v.charCodeAt(j-1) == 13)) j--;
  v = v.substring(i, j);
  var f = false;
  for (i = 0; i < v.length; i++) if (v.charAt(i) != ' ' && v.charAt(i) != '\t') { f = true; break; }
  if (!f) return '';
  else return uml(v);
 }
 if (!hirachy) hirachy = 0;
 var n = window.getComputedStyle(el).display.indexOf('inline') == -1;
 var h = '';
 for (var i = 0; i < hirachy; i++) h += ' ';
 // spezielle Element-Filter
 if (el.tagName.toLowerCase() == 'span') return ''; // keine Span-Elemente
 var s = ((n)?'\n'+h:'') + '<' + el.tagName.toUpperCase();
 for (var i = 0; i < el.attributes.length; i++) {
  var v = el.attributes[i].value;
  var name = el.attributes[i].name.toLowerCase();
  // spezielle Attribut-Filter
  if (name == 'style') continue; // keine Stylesheets
  if (name == 'href' || name == 'src') v = relativePath(v); // relative Pfade
  if (name == 'class' && (' '+v+' ').indexOf(' active ') >= 0) { v = ((' '+v+' ').split(' active ')).join(' '); v = v.substring(1, v.length-1); } // active aus ClassName entfernen
  s += ' ' + name + '="' + v + '"';
 }
 s += '>';
 var p = s.length;
 for (var i = 0; i < el.childNodes.length; i++) {
  if (el.childNodes[i].nodeType == 1) s += toFormatedCode(el.childNodes[i], hirachy+1);
  else if (el.childNodes[i].nodeType == 3) {
   var v = unformat(el.childNodes[i].nodeValue);
   if (v != '') s += ((n)?'\n '+h:'') + v;
  }
 }
 s += ((n && s.indexOf('\n', p) == p)?'\n'+h:'') + '<\/' + el.tagName.toUpperCase() + '>';
 return s;
}
function showMenuHtml () {
 var el = document.createElement('textarea');
 el.style.position = 'fixed';
 el.style.top = '10%';
 el.style.left = '10%';
 el.style.width = '80%';
 el.style.height = '80%';
 el.innerHTML = toFormatedCode(document.getElementsByTagName('ol')[0], 3);
 el.style.zIndex = 100000;
 document.body.appendChild(el);
}