if (!window.JSWindow) throw "JSWindow.js must be imported before JSWManager.js!"





function JSWManager (_parentElement) { with (this) {
 // private
 var mouseDownEV;

 // protected (darf von public gelesen werden, aber nur von ausgewaehlten Scripts geschrieben)
 this.parentElement = _parentElement; // Element, das alle Fenster beinhaltet
 this.windowClicked = false; // Bei aufsteigenden Mouse-Down-Events
 this.activeWindow = null; // Aktives Fenster
 this.layers = new Array(); // Alle layer
 this.maxZ = 1;
 this.taskbar = null;
 this.eventListeners = new Object();
 this.freed  = false;
 
 // public
 this.startZIndex = 1; // Mindest-Z-Index des hintersten Fensters
 this.effects = new Object();
 this.effects['duration'] = 500;
 this.effects['Activate'] = JSWEffect_Blend;
 this.effects['ActivateParams'] = 1;
 this.effects['Deactivate'] = JSWEffect_Blend;
 this.effects['DeactivateParams'] = 0.85;
 this.effects['Show'] = JSWEffect_Blend;
 this.effects['ShowParams'] = 1;
 this.effects['Hide'] = JSWEffect_Blend;
 this.effects['HideParams'] = 0;
 this.effects['Maximize'] = JSWEffect_ThrowBorder;
 this.effects['Normalize'] = JSWEffect_ThrowBorder;
 this.effects['Minimize'] = function (win, duration, onTerminate, x, y, params) { JSWEffect_ThrowBorder(win, duration, onTerminate, y, x, 0, 0, params); }
 this.effects['Unminimize'] = this.effects['Minimize'];
 this.effects['UnminimizeParams'] = true;
 this.minimalVisible = new Array(0, -10, -10, -10); // Im Falle gemanageder Fenster wird dieser Array als minimalVisible der Fenster gesetzt

 var create = function () {
  mouseDownEV = onEvent(document, 'mousedown', mouseDown);
 };
 
 var onEvent = function (el, event, fkt) { // provides easy eventListeners. el: Element to set the listener; event: string-name of the event(without "on"); fkt: a Function to call if the event occours, fkt is called in the scope of _this
  var _this = this;
  var oev = new Object();
  oev['f'] = function (ev) {
    // Browseruebergreifende Kompatibilitaet
    if (!ev) ev = window.event;
    if (!ev.target) ev.target = ev.srcElement;
    fkt.call(_this,ev);
   }
  oev['event'] = event;
  oev['el'] = el;
  if (window.addEventListener) el.addEventListener(event, oev['f'], false);
  else el.attachEvent('on'+event,oev['f']);
  return oev;
 };

 var mouseDown = function (ev) {
  if (activeWindow && !windowClicked) activeWindow.deactivate();
  windowClicked = false;
 }

 this.addEventListener = /* public */ function (type, fkt) {
  if (this.freed) throw 'Object is freed';
  if (!this.eventListeners[type]) this.eventListeners[type] = new Array();
  this.eventListeners[type].push(fkt);
 }

 this.removeEventListener = /* public */ function (type, fkt) {
  if (this.freed) throw 'Object is freed';
  if (!this.eventListeners[type]) return;
  var i = 0;
  while (i < this.eventListeners[type].length) if (this.eventListeners[type][i] == fkt) this.eventListeners[type].splice(i, i+1);
  else i++;
  if (this.eventListeners[type].length == 0) delete this.eventListeners[type];
 }

 this.checkLayers = /* public */ function (dontSort) {
  if (this.freed) throw 'Object is freed';
  if (this.layers.length == 0) return;
  if (!dontSort) this.layers.sort(function (l1, l2) { if (l1.topMost && !l2.topMost) return 1; if (!l1.topMost && l2.topMost) return -1; return l1.minZ - l2.minZ; });
  this.layers[0].fromMinZ(this.startZIndex);
  for (var i = 1; i < this.layers.length; i++) this.layers[i].fromMinZ(this.layers[i-1].maxZ+1);
  this.maxZ = this.layers[this.layers.length-1].maxZ;
 }
 
 this.bringLayerToFront = /* public */ function (layer) {
  if (this.freed) throw 'Object is freed';
  this.layers.sort(function (l1, l2) { if (l1.topMost && !l2.topMost) return 1; if (!l1.topMost && l2.topMost) return -1; return l1.minZ - l2.minZ; });
  var i = 0;
  while (i < this.layers.length) if (this.layers[i] == layer) break; else i++;
  if (i >= this.layers.length || this.layers[i] != layer) return; // Layer ist nicht Teil dieses Managers
  for (i = i; i < this.layers.length - 1; i++) {
   if (this.layers[i+1].topMost && !layer.topMost) break;
   this.layers[i] = this.layers[i+1];
   this.layers[i+1] = layer;
  }
  this.checkLayers(true);
 }
 
 this.free = /* public */ function () {
  if (this.freed) throw 'Object is freed';
  mouseDownEV.el.removeEventListener(mouseDownEV.event, mouseDownEV.f);
  var l = layers;
  layers = new Array();
  for (var i = 0; i < l.length; i++) l[i].free();
  if (this.taskbar) this.taskbar.free();
  this.freed = true;
  for (var key in this) if (typeof this[key] == 'object') this[key] = null; if (window.opera) opera.collect();
 }
 
 create();
} }





if (!lang) var lang = new Object();
if (!lang['JSWTaskbar']) {
 lang['JSWTaskbar'] = new Array('de', // first element must specify the Language
  'Men&uuml;');
 try { langTranslate('JSWTaskbar'); } catch (e) {}
}
function JSWTaskbar (_mgr) { with (this) {
 // private
 var mgr = _mgr;
 var el = new Object();
 var _this = this;
 var z = 1;
 var menu = null;
 var freed  = false;
 
 // public (readonly)
 this.menubutton = null;
 this.menuOpen = false;
 
 // public
 this.autoBlendOut = false;

 var create = function () {
  mgr.taskbar = _this;
  // Taskbar-ELemente erstellen
  function createEl (name, type, parent) {
   el[name] = document.createElement(type);
   if (type == 'a') el[name].href = 'javascript:';
   el[name].className = 'JSW ' + name;
   if (parent) parent.appendChild(el[name]);
  }
  createEl('Taskbar', 'div', null);
  createEl('MenuButton', 'a', el['Taskbar']);
  createEl('BarButtons', 'div', el['Taskbar']);
  el['Taskbar'].style.zIndex = 1;
  el['Taskbar'].style.position = (mgr.parentElement == document.body)?'fixed':'absolute';
  el['MenuButton'].innerHTML = lang['JSWTaskbar'][1];
  el['MenuButton'].onclick = openMenu;
  mgr.parentElement.appendChild(el['Taskbar']);
  menubutton = el['MenuButton'];
  // Events
  var this_ = this;
  if (window.addEventListener) el['Taskbar'].addEventListener('mousedown', function () { mouseDown.call(this_); }, false); else el['Taskbar'].attachEvent('onmousedown', function () { mouseDown.call(this_); });
  // minimalVisible-clip fuer Fenster einstellen
  if (!autoBlendOut) {
   mgr.minimalVisible[0] = el['Taskbar'].offsetHeight;
  }
 }

 var mouseDown = function () {
  mgr.windowClicked = true;
 }
 
 this.openMenu = /* public */ function () {
  if (this.freed) throw 'Object is freed';
  if (!menu || menuOpen) return;
  menuOpen = true;
  menu.style.display = 'block';
  menu.style.top = el['Taskbar'].offsetTop + el['Taskbar'].offsetHeight + 'px';
  menu.style.left = el['Taskbar'].offsetLeft + 'px';
  menu.style.zIndex = z + 2;
  document.addEventListener('mousedown', menuCloseClick, false);
 }
 
 this.closeMenu = /* public */ function () {
  if (this.freed) throw 'Object is freed';
  if (!menuOpen) return;
  menuOpen = false;
  document.removeEventListener('mousedown', menuCloseClick);
  menu.style.display = 'none';
 }
 
 var menuCloseClick = /* private */ function (ev) {
  var p = ev.target;
  var b = false;
  while (p) { if (p == menu) { b = true; break; } p = p.parentElement; }
  if (!b) closeMenu();
 }
 
 this.setMenu = /* public */ function (el) {
  if (this.freed) throw 'Object is freed';
  menu = el;
 }
 
 this.setMinZ = /* protected */ function (minZ) {
  if (this.freed) throw 'Object is freed';
  if (minZ < z - 1) return;
  z = minZ + 1;
  el['Taskbar'].style.zIndex = z;
 }

 this.appendButton = /* public */ function (but) {
  if (this.freed) throw 'Object is freed';
  el['BarButtons'].appendChild(but);
 }

 this.removeButton = /* public */ function (but) {
  if (this.freed) throw 'Object is freed';
  el['BarButtons'].removeChild(but);
 }

 this.free = /* public */ function () {
  if (this.freed) throw 'Object is freed';
  mgr.taskbar = null;
  mgr.parentElement.removeChild(el['Taskbar']);
  el = null;
  this.freed = true;
  for (var key in this) if (typeof this[key] == 'object') this[key] = null; if (window.opera) opera.collect();
 }

 create();
} }






function JSWLayer (_mgr) {
 // private
 this.mgr = _mgr;
 this.taskbar = this.mgr.taskbar;
 this.freed  = false;

 // protected (darf von public gelesen werden, aber nur von ausgewaehlten Scripts geschrieben)
 this.windows = new Array();
 this.minZ = this.mgr.startZIndex;
 this.maxZ = this.mgr.startZIndex;
 this.el = null;
 
 // public folgt nach Konstruktor

 // initialization
 this.mgr.layers.push(this);
 if (this.taskbar) {
  this.el = new Object();
  var _this = this;
  function createEl (name, type, parent) {
   _this.el[name] = document.createElement(type);
   if (type == 'a') _this.el[name].href = 'javascript:';
   _this.el[name].className = 'JSW ' + name;
   if (parent) parent.appendChild(_this.el[name]);
  }
  createEl('TaskbarButton', 'a', null);
  createEl('CornerLeft', 'span', this.el['TaskbarButton']);
  createEl('CornerRight', 'span', this.el['TaskbarButton']);
  createEl('Background', 'span', this.el['TaskbarButton']);
  createEl('Title', 'span', this.el['TaskbarButton']);
  this.taskbar.appendButton(this.el['TaskbarButton']);
  if (window.addEventListener) this.el['TaskbarButton'].addEventListener('click', function () { _this.butClick.call(_this); }, false); else this.el['TaskbarButton'].attachEvent('onclick', function () { _this.butClick.call(_this); });
  this.el['Title'].innerHTML = '&nbsp;';
  if (window.addEventListener) this.el['TaskbarButton'].addEventListener('DOMSubtreeModified', function () { _this.resize.call(_this) }, false);
  else this.el['TaskbarButton'].attachEvent('resize', function () { _this.resize.call(_this) });
 }
}

JSWLayer.prototype = {
 _topMost : false, get topMost () { return this._topMost; }, set topMost (v) { if (v == this._topMost) return; this._topMost = v; this.mgr.bringLayerToFront(this); },
 _mainWindow : null, get mainWindow () { return this._mainWindow; }, set mainWindow (v) { this._mainWindow = v; this.updateIconTitle(); },
 _icon : null, get icon () { if (this._icon == null) { if (this._mainWindow) return this._mainWindow.icon; return ''; } return this._icon; }, set icon (v) { this._icon = v; this.updateIconTitle(); },
 _title : null, get title () { if (this._title == null) { if (this._mainWindow) return this._mainWindow.title; return ''; } return this._title; }, set title (v) { this._title = v; this.updateIconTitle(); },
 visibility : 1,
 blinkMaxF : 1.5,
 blinkMinF : 0.3,
 blinkHalfFTime : 1,
 blinkMinAmp : 0.2,
 blinkHalfAmpTime : 4
}

JSWLayer.prototype.getButtonPos = /* protected */ function () {
 if (this.freed) throw 'Object is freed';
 var p = this.el['TaskbarButton'];
 var r = new Array(p.offsetWidth/2, p.offsetHeight);
 do {
  r[0] += p.offsetLeft;
  r[1] += p.offsetTop;
  p = p.offsetParent;
 } while (p && p != this.mgr.parentElement);
 return r;
}

JSWLayer.prototype.butClick = /* private */ function () {
 if (this.freed) throw 'Object is freed';
 if (this.windows.length == 0) return;
 this.mgr.bringLayerToFront(this);
 var f = false;
 var activeWin = null;
 for (var i = 0; i < this.windows.length; i++) {
  if (this.windows[i].active) activeWin = this.windows[i];
  if (this.windows[i].minimized) {
   this.windows[i].unminimize();
   f = true;
  }
 }
 if (!f && activeWin) for (var i = 0; i < this.windows.length; i++) this.windows[i].minimize();
 if (!activeWin) {
  if (this.mainWindow) this.mainWindow.activate();
  else this.windows[0].activate();
 }
}

JSWLayer.prototype.updateIconTitle = /* protected */ function () {
 if (this.freed) throw 'Object is freed';
 this.el['Title'].innerHTML = this.title;
 if (this.icon != '') {
  if (!this.el['Icon']) {
   this.el['Icon'] = document.createElement('img');
   this.el['Icon'].className = 'JSW Icon';
   this.el['TaskbarButton'].insertBefore(this.el['Icon'], this.el['Title']);
  }
  this.el['Icon'].src = this.icon;
 } else if (this.el['Icon']) {
  this.el['TaskbarButton'].removeChild(this.el['Icon']);
  delete this.el['Icon'];
 }
}

JSWLayer.prototype.checkVisible = /* protected */ function () {
 if (this.freed) throw 'Object is freed';
 if (this.visibility != 1 || !this.el) return;
 var v = false;
 for (var i = 0; i < this.windows.length; i++) if (this.windows[i].visible) { v = true; break; }
 this.el['TaskbarButton'].style.display = (v)?'inline-block':'none';
}

JSWLayer.prototype.appendWindow = /* protected */ function (win) {
 if (this.freed) throw 'Object is freed';
 if (this.windows.length == 0) { this.minZ = win.z; this.maxZ = win.z; }
 else { this.maxZ++; win.setZ(this.maxZ); }
 this.windows.push(win);
 var _this = this;
 win.minimizePoint = function () { return _this.getButtonPos.call(_this); };
 this.fromMinZ(this.minZ);
 this.mgr.checkLayers();
 this.checkActive();
 this.checkVisible();
}

JSWLayer.prototype.checkActive = /* public */ function () {
 if (this.freed) throw 'Object is freed';
 var isActive = false;
 for (var i = 0; i < this.windows.length; i++) if (this.windows[i].active) isActive = true;
 if (isActive && this.alertTimer) this.alertEffect(2);
 if (this.el) this.el['TaskbarButton'].className = (isActive)?'JSW TaskbarButton active':'JSW TaskbarButton';
}

JSWLayer.prototype.removeWindow = /* protected */ function (win) {
 if (this.freed) throw 'Object is freed';
 var i = 0;
 while (i < this.windows.length) if (this.windows[i] == win) break; else i++;
 if (i >= this.windows.length || this.windows[i] != win) return;
 this.windows.splice(i, 1);
 if (win == this.mainWindow || this.windows.length == 0) this.free();
}

JSWLayer.prototype.fromMinZ = /* protected */ function (newMinZ, dontSort) {
 if (this.freed) throw 'Object is freed';
 if (this.windows.length == 0) { this.minZ = newMinZ; this.maxZ = newMaxZ; return; }
 if (!dontSort) this.windows.sort(function (w1, w2) { if (w1.topMost && !w2.topMost) return 1; if (!w1.topMost && w2.topMost) return -1; return w1.z - w2.z; });
 this.minZ = newMinZ--;
 for (var i = 0; i < this.windows.length; i++) this.windows[i].setZ(++newMinZ);
 this.maxZ = newMinZ;
}

JSWLayer.prototype.bringWindowToFront =  /* public */ function (win) {
 if (this.freed) throw 'Object is freed';
 this.windows.sort(function (w1, w2) { if (w1.topMost && !w2.topMost) return 1; if (!w1.topMost && w2.topMost) return -1; return w1.z - w2.z; });
 var i = 0;
 while (i < this.windows.length) if (this.windows[i] == win) break; else i++;
 if (i >= this.windows.length || this.windows[i] != win) return; // win ist nicht Teil dieses Layers
 for (i = i; i < this.windows.length-1; i++) {
  if (this.windows[i+1].topMost && !win.topMost) break;
  this.windows[i] = this.windows[i+1];
  this.windows[i+1] = win;
 }
 this.fromMinZ(this.minZ, true);
}

JSWLayer.prototype.resize = /* private */ function () {
 if (this.el && this.el['Progress']) this.el['Progress'].style.clip = 'rect(auto, '+this.progress*this.el['Progress'].offsetWidth+'px, auto, auto)';
}

JSWLayer.prototype.setProgress = /* public */ function (p) {
 if (this.freed) throw 'Object is freed';
 if (!this.el) return;
 this.progress = p;
 if (isNaN(p)) {
  if (this.el['Progress']) {
   this.el['TaskbarButton'].removeChild(this.el['Progress']);
   this.el['Progress'] = null;
  }
 } else {
  if (!this.el['Progress']) {
   this.el['Progress'] = document.createElement('span');
   this.el['Progress'].className = 'JSW Progress';
   this.el['TaskbarButton'].insertBefore(this.el['Progress'], this.el['Title']);
  }
  this.resize();
 }
}

JSWLayer.prototype.alertEffect = /* private */ function (state) {
 switch (state) {
  case 0:
   this.el['Alert'] = document.createElement('div');
   this.el['Alert'].style.opacity = 0;
   this.el['Alert'].className = 'JSW Alert';
   this.el['TaskbarButton'].insertBefore(this.el['Alert'], this.el['Title']);
   break;
  case 1:
   with (this) {
    var t = (getTickCount() - alertStart) / 1000;
    var s = (blinkMinAmp/2 - blinkHalfAmpTime*(blinkMinAmp - 1)/(2*(t + blinkHalfAmpTime)))*Math.cos((2*Math.PI*blinkMaxF*blinkHalfFTime - 2*Math.PI*blinkMinF*blinkHalfFTime)*Math.log(t + blinkHalfFTime) + (2*Math.PI*blinkMinF*blinkHalfFTime - 2*Math.PI*blinkMaxF*blinkHalfFTime)*Math.log(blinkHalfFTime) + 2*Math.PI*blinkMinF*t) + 1/2;
   }
   this.el['Alert'].style.opacity = s;
   break;
  case 2:
   this.el['TaskbarButton'].removeChild(this.el['Alert']);
   delete this.el['Alert'];
   if (this.alertTimer) window.clearInterval(this.alertTimer);
   this.alertTimer = null;
   this.alertStart = 0;
   break;
 }
}

JSWLayer.prototype.alert = /* public */ function () {
 if (this.freed) throw 'Object is freed';
 if (!this.el) return;
 this.alertStart = getTickCount();
 var _this = this;
 if (!this.alertTimer) {
  this.alertEffect(0);
  this.alertTimer = window.setInterval(function () { _this.alertEffect.call(_this, 1); }, 40);
 }
}

JSWLayer.prototype.free = /* public */ function () {
 if (this.freed) throw 'Object is freed';
 if (this.alertTimer) window.clearInterval(this.alertTimer);
 if (this.taskbar) this.taskbar.removeButton(this.el['TaskbarButton']);
 var w = this.windows;
 this.windows = new Array();
 for (var i = 0; i < w.length; i++) w[i].free();
 for (var i = 0; i < this.mgr.layers.length; i++) if (this.mgr.layers[i] == this) { this.mgr.layers.splice(i, 1); break; }
 this.freed = true;
 for (var key in this) if (typeof this[key] == 'object') this[key] = null; if (window.opera) opera.collect();
}







function JSWindowManaged (_mgr, _layer, _el, _id) {
 // protected (darf von public gelesen werden, aber nur von ausgewaehlten Scripts geschrieben)
 this.mgr = _mgr;
 this.layer = _layer;
 this.active = false;
 this.z = this.mgr.startZIndex;
 
 // public readonly
 this.id = '';
 if (_id) this.id = _id; else if (_el && _el.id != '') this.id = _el.id;
 this.recoveryURL = '';
 
 // public
 this.topMost = false;
 
 // initialization
 if (window.jsw && this.id != '') { // doppeltes oeffnen bei idWindows verhindern
  if (window.jsw.idWin[this.id]) {
   jsw.idWin[this.id].show();
   this.callEventListener('alreadyExists', jsw.idWin[this.id]);
   this.id = '';
   this.free();
   return null;
  } else jsw.idWin[this.id] = this;
 }
 this.effects = this.mgr.effects;
 this.minimalVisible = this.mgr.minimalVisible;
 JSWindow.call(this, _el); // inherited
 if (this.hasAtr(this.el['OuterBox'],'active')) { this.active = true; this.activate(); }
 if (_el) { this.z = (window.getComputedStyle)?window.getComputedStyle(_el)['zIndex']:_el.currentStyle['zIndex']; if (isNaN(this.z)) this.z = this.mgr.startZIndex; }
 else this.el['OuterBox'].style.zIndex = this.z;
 if (!this.layer) {
  this.layer = new JSWLayer(this.mgr);
  this.layer.mainWindow = this;
 }
 this.layer.appendWindow(this);
}

JSWindowPrototype = function () { }
JSWindowPrototype.prototype = JSWindow.prototype;
JSWindowManaged.prototype = new JSWindowPrototype();
JSWindowManaged.prototype._super = JSWindow.prototype;

JSWindowManaged.prototype.setRecoveryURL = /* protected */ function (url) {
 this.recoveryURL = url;
 this.callEventListener('recoveryURLChanged');
}

JSWindowManaged.prototype.show = /* public */ function (parent) {
 if (this.freed) throw 'Object is freed';
 if (this.visible) { this.activate(); this.bringToFront(); }
 this.mgr.checkLayers();
 if (!parent && !this.parentElement) parent = this.mgr.parentElement;
 this._super.show.call(this, parent); // inherited
 this.layer.checkVisible();
}

JSWindowManaged.prototype.titleToID = /* public */ function () {
 if (this.freed) throw 'Object is freed';
 if (this.id != '' || this.title == '') return;
 var t = this.title.split('');
 for (var i = 0; i < t.length; i++) {
  var c = t[i].charCodeAt([0]);
  if (c < 65 || (c > 90 && c < 97) || c > 122) t[i] = '_' + c.toString(16);
 }
 this.setID(t.join(''));
}

JSWindowManaged.prototype.setID = /* public */ function (_id) {
 if (this.freed) throw 'Object is freed';
 if (!_id) return;
 if (window.jsw && _id != '' && jsw.idWin[_id] && jsw.idWin[_id] != this) {
  jsw.idWin[_id].activate();
  jsw.idWin[_id].bringToFront();
  this.callEventListener('alreadyExists', jsw.idWin[_id]);
  this.id = '';
  this.free();
  return;
 }
 this.id = _id;
 this.el['OuterBox'].id = _id;
 if (window.jsw) jsw.idWin[_id] = this;
}

JSWindowManaged.prototype.removeID = /* public */ function () {
 if (this.freed) throw 'Object is freed';
 if (!this.id || this.id == '') return;
 if (window.jsw.idWin[this.id]) delete jsw.idWin[this.id];
 this.id = '';
}

JSWindowManaged.prototype.hide = /* public */ function () {
 if (this.freed) throw 'Object is freed';
 this._super.hide.call(this); // inherited
 this.layer.checkVisible();
}

JSWindowManaged.prototype.setZ = /* protected */ function (newZ) {
 if (this.freed) throw 'Object is freed';
 if (this.excluded) return;
 if (newZ < this.mgr.startZIndex) newZ = this.mgr.startZIndex;
 this.z = newZ;
 this.el['OuterBox'].style.zIndex = newZ;
 if (this.mgr.taskbar) this.mgr.taskbar.setMinZ(newZ);
 this.callEventListener('zChange');
}

JSWindowManaged.prototype.mouseDown = /* private */ function (ev) {
 // Aktivieren des Fensters
 this.mgr.windowClicked = true; // Deaktivierung verhindern
 this.activate();
 this.bringToFront();
 this._super.mouseDown.call(this, ev); // inherited
}

JSWindowManaged.prototype.bringToFront = /* public */ function () {
 if (this.freed) throw 'Object is freed';
 this.layer.bringWindowToFront(this);
 this.mgr.bringLayerToFront(this.layer);
}

JSWindowManaged.prototype.setTitle = /* protected */ function (v) {
 if (this.freed) throw 'Object is freed';
 this._super.setTitle.call(this, v); // inherited
 if (this.layer) this.layer.updateIconTitle();
}

JSWindowManaged.prototype.setIcon = /* protected */ function (v) {
 this._super.setIcon.call(this, v); // inherited
 this.layer.updateIconTitle();
}

JSWindowManaged.prototype.exclude = /* public */ function (click) {
 if (this.freed) throw 'Object is freed';
 this._super.exclude.call(this, click); // inherited
 this.onEvent(this.excludedWindow, 'blur', function () { this.deactivate(true); });
 this.onEvent(this.excludedWindow, 'focus', function () { this.activate(true); });
}

JSWindowManaged.prototype.activate = /* public */ function (loop) {
 if (this.freed) throw 'Object is freed';
 if (this.mgr.activeWindow && this.mgr.activeWindow != this) this.mgr.activeWindow.deactivate();
 this.mgr.activeWindow = this;
 if (this.active) return;
 // Aktivieren
 this.active = true;
 this.setAtr(this.el['OuterBox'], 'active');
 this.layer.checkActive();
 if (!loop && this.excluded) this.excludedWindow.focus();
 this.callEventListener('activate');
 // Frame-cover entfernen
 if (this.el['FrameCover']) {
  this.el['OuterBox'].removeChild(this.el['FrameCover']);
  this.el['FrameCover'] = null;
 }
 // Effekt
 if (this.minimized || this.excluded) return;
 if (this.effects && this.effects['Activate']) this.effects['Activate'](this, this.effects['duration'], null, this.effects['ActivateParams']);
}

JSWindowManaged.prototype.deactivate = /* public */ function (loop) {
 if (this.freed) throw 'Object is freed';
 if (!this.active) return;
 // Deaktivieren
 this.active = false;
 this.rmAtr(this.el['OuterBox'], 'active');
 this.layer.checkActive();
 if (!loop && this.excluded) this.excludedWindow.blur();
 this.callEventListener('deactivate');
 // Frames ueberdecken
 var b = false;
 var f = this.el['InnerBox'].getElementsByTagName('iframe');
 for (var i = 0; i < f.length; i++) if (!f[i].communicator || !(f[i].communicator.siteAllows & 8)) { b = true; break; }
 if (b) {
  this.el['FrameCover'] = document.createElement('div');
  this.el['FrameCover'].className = 'JSW FrameCover';
  this.el['OuterBox'].appendChild(this.el['FrameCover']);
 }
 // Effekt
 if (this.minimized || this.excluded) return;
 if (this.effects && this.effects['Deactivate']) this.effects['Deactivate'](this, this.effects['duration'], null, this.effects['DeactivateParams']);
}

JSWindowManaged.prototype.free = /* public */ function () {
 if (this.freed) throw 'Object is freed';
 try {
  if (this.mgr.activeWindow == this) this.mgr.activeWindow = null;
  this.layer.removeWindow(this);
 } catch (e) {}
 if (this.id != '' && jsw) delete jsw.idWin[this.id];
 this._super.free.call(this); // inherited
}