function JSWSystem () { with (this) {
 // private
 var onStart = new Array();
 var selfScriptPath = document.getElementsByTagName('script')[document.getElementsByTagName('script').length-1].src;
 if (selfScriptPath.indexOf('\/JSWSystem.js') < 0) throw 'JSWSystem.js kann seinen eigenen Pfad nicht feststellen! Die Datei JSWSystem.js darf nicht umbenannt werden und muss beim laden der Seite geladen werden.';
 selfScriptPath = selfScriptPath.substring(0, selfScriptPath.lastIndexOf('\/')+1);
 var applications = new Array();
 
 // protected
 this.selfHostname = getHostnameAndProtocol(self.location.href);
 this.units = new Object();

 // public (Readonly)
 this.mgr = null;
 this.taskbar = null;
 this.whitelist = new Array();
 this.idWin = new Object();
 this.standardPos = { top : 100, left : 100, width : 400, height : 200, right : Number.NaN, bottom : Number.NaN };
 this.standardBehavoir = 16;
 this.paths = { icons : '../icons/', units : 'modules/', designInfo : '../css/designinfo.html' };
  
 this.start = /* public */ function () {
  // check
  if (mgr) return;
  var el = document.body;
  if (!el) return;
  if (!window.JSWManager) throw 'JSWManager.js must be imported before JSWSystem.js!';
  if (!window.FrameCommunicator) throw 'Zum Erstellen von JSWSystem wird frameCommunicator.js benoetigt!';
  // initialization
  for (var key in paths) paths[key] = absolutePath(paths[key], selfScriptPath); // Paths richtig setzen (unbedingt zuerst!)
  mgr = new JSWManager(el);
  taskbar = new JSWTaskbar(mgr);
  if (document.getElementById('menu')) taskbar.setMenu(document.getElementById('menu'));
  autoCreateWindows();
  for (var i = 0; i < onStart.length; i++) onStart[i]();
  onStart = null;
  mgr.addEventListener('hide', onWinHide);
  loadUnit(paths.units, 'switchableDesign', window, function (u) {
   u.unit.addDesignInfoFromFile(paths.designInfo, function () { u.unit.loadDesign(/* default */); });
  });
  loadUnit(paths.units, 'adressbar', window, null);
  window.setTimeout(function () { processSite(document.body); }, 1000);
 }

 if (document.addEventListener) document.addEventListener('DOMContentLoaded', start, false);
 
 var onWinHide = /* private */ function (win) { // wird aufgerufen, wenn ein Fenster geschlossen wird. Nach dem Schliessen werden auch die ContentWindows der Iframes des Fensters freigegeben (Auch, wenn das Fenster selbst nicht freigegeben wird)!
  for (var i = 0; i < win.el['InnerBox'].getElementsByTagName('iframe').length; i++) removeUnitDependency(win.el['InnerBox'].getElementsByTagName('iframe')[i].contentWindow);
 }

 var autoCreateWindows = function () {
  var el = mgr.parentElement.getElementsByTagName('div');
  for (var i = 0; i < el.length; i++) {
   var n = ' '+el[i].className+' ';
   if (n.indexOf(' JSW ') < 0 || n.indexOf(' OuterBox ') < 0) continue;
   (new JSWindowManaged(mgr, null, el[i])).setRecoveryURL((el[i].id)?'$'+el[i].id:'');
  }
 }

 var isNotInWhitelist = /* private */ function (src) {
  if (getHostnameAndProtocol(src) == selfHostname) return false;
  for (var i = 0; i < whitelist.length; i++) if (whitelist[i].test(src)) return false;
  return true;
 }

 var titleFormURL = /* private */ function (url) {
  url = url.split('\/');
  var i = url.length-1;
  while (i > 0 && url[i] == '') i--;
  return url[i];
 }
 
 var loadUnit = /* private */ function (uPath, uName, dependency, onload) {
  var u = units[uName];
  if (u && units[uName].loaded) { // Unit wurde vollstaendig geladen
   u.dependencies.push(dependency);
   onload(u);
  } else if (u) { // Unit wird bereits geladen
   u.dependencies.push(dependency);
   var oldOnload = u.onload;
   u.onload = function () {
    oldOnload();
    onload(u);
   }
  } else { // Unit wurde noch nicht geladen
   u = new Object();
   units[uName] = u;
   u.name = uName;
   u.dependencies = new Array(dependency); // units/windows, die diese Unit benoetigen
   u.uses = new Array(); // Units, die diese Unit braucht
   u.loaded = false;
   u.onload = function () {
    u.loaded = true;
    if (onload) onload(u);
   }
   u.forceUnload = function () {
    try { u.unit.free(); } catch (e) { }
    document.getElementsByTagName('head')[0].removeChild(u.script);
    delete units[u.name];
    removeUnitDependency(u);
    for (var key in u) if (typeof u[key] == 'object') u[key] = null; if (window.opera) opera.collect();
    u = null;
   }
   u.script = document.createElement('script');
   u.script.type = 'text/javascript';
   addOnStart(function () { // sicherstellen, dass units erst nach Start von JSWSystem eingebunden werden!
    u.script.src = uPath + uName + '.js';
    document.getElementsByTagName('head')[0].appendChild(u.script);
   });
  }
 }
 
 this.dynamicallyLoadUnit = /* public */ function (uLocation, onload) {
  var p = absolutePath(uLocation, selfScriptPath).split('\/');
  var n = p.pop().split('.')[0];
  loadUnit(p.join('\/') + '\/', n, new Object(), onload);
 }

 this.uses = /* public */ function (uName, win) {
  if (!win.jswUnits) win.jswUnits = new Array();
  win.jswUnits.push(uName);
  loadUnit(paths.units, uName, win, function (u) {
   if (win.jswApplication) checkForApplicationStart(win.jswApplication);
   if (units[uName].onUse) units[uName].onUse(win);
  });
 }
 
 this.dependencies = /* protected */ function (unit, depends, onDependenciesLoaded) {
  var loaded = 0;
  for (var i = 0; i < depends.length; i++) loadUnit(paths.units, depends[i], unit, function (u) {
   unit.uses.push(i);
   loaded++;
   if (loaded >= depends.length) onDependenciesLoaded();
  });
 }
 
 var removeUnitDependency = /* private */ function (unit_win) {
  var a = new Array();
  for (var key in units) {
   if (!units[key]) continue;
   for (var j = units[key].dependencies.length - 1; j >= 0; j--) if (units[key].dependencies[j] == unit_win) units[key].dependencies.splice(j, 1);
   if (units[key].dependencies.length == 0) a.push(units[key]);
  }
  for (var i = 0; i < a.length; i++) a[i].forceUnload();
  a = null;
 }
 
 this.enumWindows = /* public */ function (callback) {
  if (!mgr) return;
  for (var i = 0; i < this.mgr.layers.length; i++) for (var j = 0; j < this.mgr.layers[i].windows.length; j++) callback(this.mgr.layers[i].windows[j]);
 }

 this.processSite = /* public */ function (el, mainWindow) {
  function addListener (el, max, ex, sameLayer) {
   el.addEventListener('click', function (ev) {
    var b = 19;
    if (max) b += 4;
    if (ex) b += 8;
    var l = null;
    if (sameLayer && mainWindow) l = mainWindow.layer;
    var w = jsw.createWindowFromSite(this.href, b, l);
    if (ev.preventDefault) ev.preventDefault();
    return false;
   }, false);
   el.jswProcessed = true;
  }
  var a = el.getElementsByTagName('a');
  for (var i = 0; i < a.length; i++) if ((' '+a[i].className+' ').indexOf(' WindowLink ') != -1 && !a[i].jswProcessed) addListener(a[i], ((' '+a[i].className+' ').indexOf(' openMaximized ') != -1), ((' '+a[i].className+' ').indexOf(' openExcludable ') != -1), ((' '+a[i].className+' ').indexOf(' openInSameLayer ') != -1));
 }

 this.addOnStart = /* public */ function (fkt) {
  if (mgr) fkt();
  else onStart.push(fkt);
 }

 this.addURLToWhitelist = /* private */ function (url) {
  var rep = new RegExp('([^\\w&^\\*])', 'g');
  var host = getHostnameAndProtocol(url);
  var i = host.length;
  host = host.replace(rep, '\\$1');
  var path = url.substring(i, url.length).replace(rep, '\\$1');
  if (path == '' && host.length > 0 && host.charAt(host.length-1) == '*') path = '*';
  while (host.length > 0 && host.charAt(host.length-1) == '*') host = host.substring(0, host.length-1);
  if (host == '') throw 'URL has wrong syntax';
  rep = new RegExp('\\*', 'g');
  path = path.replace(rep, '[a|^a]*'); // innerhalb des path-Bereiches koennen die * fuer beliebige Inhalte stehen
  // innerhalb des hostname-Bereiches haben die * spezielle Aufgaben
  var a = host.split('\\\:\\\/\\\/');
  if (a.length == 1) {
   a = a[0].split('*');
   if (a.length == 2) {
    host = a[0] + '(\\w)*\\:\\/\\/((\\w)+\\.)*' + a[1];
   } else throw 'URL has wrong syntax';
  } else if (a.length == 2) {
   rep = new RegExp('(\\*)', 'g');
   a[0] = a[0].replace(rep, '(\\w)*');
   a[1] = a[1].replace(rep, '((\\w)+\\.)*');
   host = a[0] + '\\:\\/\\/' + a[1];
  } else throw 'URL has wrong syntax';
  whitelist.push(new RegExp('\^'+host+path));
 }
 
 var checkForApplicationStart = /* private */ function (app) {
  if (app.started || !app.loaded) return;
  if (app.win.jswUnits) for (var i = 0; i < app.win.jswUnits.length; i++) if (!units[app.win.jswUnits[i]].loaded) return;
  if (!app.win.main) throw app.frame.src + ' is not a valid jsw-application!';
  app.started = true;
  app.win.main(app.outerBox);
 }
 
 this.runApplication = /* public */ function (url, params) {
  url = absolutePath(url, self.location.href);
  if (url.indexOf(getHostnameAndProtocol(window.location.href)) != 0) throw 'Applications must be of the same domain!';
  var a = new Object();
  applications.push(a);
  a.loaded = false;
  a.started = false;
  a.params = params;
  a.createMainWindow = function (pos) {
   var w = new JSWindowManaged(mgr, null, a.outerBox);
   a.mainWindow = w;
   w.mainFrame = a.frame;
   a.communicator = new FrameCommunicator(a.frame);
   w.pos = (pos)?pos:clone(standardPos);
   w.setPos();
   w.title = a.communicator.contentTitle;
   w.show();
  }
  a.terminate = function () {
   if (a.win) {
    if (a.win.terminate) a.win.terminate();
    removeUnitDependency(a.win);
   }
   a.frame.src = '';
   if (a.mainWindow) a.mainWindow.free();
   else document.body.removeChild(a.outerBox);
  }
  // inner- und Outer box, falls Anwendung ein MainWindow erzeugen mchte
  a.outerBox = document.createElement('div');
  a.outerBox.className = 'JSW OuterBox';
  a.outerBox.style.visibility = 'hidden';
  document.body.appendChild(a.outerBox);
  a.innerBox = document.createElement('div');
  a.innerBox.className = 'JSW InnerBox';
  a.outerBox.appendChild(a.innerBox);
  // Application frame
  a.frame = document.createElement('iframe');
  a.frame.addEventListener('load', function () {
   a.loaded = true;
   a.win = a.frame.contentWindow;
   a.win.jswApplication = a;
   checkForApplicationStart(a);
  });
  a.frame.src = url;
  a.frame.style.marginBottom = '-4px';
  a.frame.style.width = '100%';
  a.frame.style.height = '100%';
  a.frame.style.border = '0px none transparent';
  a.innerBox.appendChild(a.frame);
 }
 
 this.createWindowFromSite = /* public */ function (url, behavoir, layer) {
  if (!behavoir) behavoir = standardBehavoir;
  start();
  url = absolutePath(url);
  if (isNotInWhitelist(url)) return;
  // window erstellen
  var w = new JSWindowManaged(mgr, layer, null);
  if (w.freed) return null; // Fenster hat sich selbst freigegeben
  w.pos = clone(standardPos);
  w.title = titleFormURL(url);
  // iframe-Element erstellen
  var f = document.createElement('iframe');
  f.style.marginBottom = '-4px';
  f.style.width = '100%';
  f.style.height = '100%';
  f.style.border = '0px none transparent';
  w.el['InnerBox'].appendChild(f);
  // communicator erstellen
  var c = new FrameCommunicator(f);
  c.onTitleChanged = function (title) { if (title != '') w.title = title; };
  c.onURLChanged = function (host, url) { w.setRecoveryURL(url); };
  w.mainFrame = f;
  // Seite laden
  w.showFrameload(mgr.parentElement);
  var load = function () {
   if (w.freed) return null; // Fenster hat sich selbst freigegeben
   if (behavoir & 4) w.maximize();
   if (behavoir & 8) w.excludable = true;
   if (behavoir & 16) w.titleToID();
   if (w.freed) return null; // Fenster hat sich selbst freigegeben
   w.show();
   if (behavoir & 1) w.activate();
   if (behavoir & 2) w.bringToFront();
   if (behavoir & 32) w.exclude();
   if (behavoir & 64) w.minimize();
   if (behavoir & 128) JSWEffect_terminate(w);
  }
  if (document.addEventListener) f.addEventListener('load', load, false); else f.attachEvent('onload', load);
  f.src = url;
  return w;
 }
 
 this.createWindowFromFile = /* public */ function (filename) { // funktioniert noch nicht richtig
  start();
  filename = absolutePath(filename);
  if (isNotInWhitelist(filename)) return;
  // Fenster erstellen
  var w = new JSWindowManaged(mgr, null, null);
  w.pos.top = 100;
  w.pos.left = 100;
  w.pos.width = 400;
  w.pos.height = 200;
  // Inhalt holen
  var xmlhttp = (window.XMLHttpRequest)?(new XMLHttpRequest()):(new ActiveXObject("Microsoft.XMLHTTP"));
  xmlhttp.onreadystatechange = function () {
   if (xmlhttp.readyState != 4) { return; }
   w.el['InnerBox'].innerHTML = xmlhttp.responseText;
   w.show(mgr.parentElement);
  }
  xmlhttp.open('get', filename, true);
  xmlhttp.send();
 }

 start(); 
}}

// initialization
window.jswMainWindow = null;
window.jsw = (function () {
 if (parent != self && parent.jsw) {
  for (var i = 0; i < parent.document.getElementsByTagName('iframe').length; i++) {
   if (parent.document.getElementsByTagName('iframe')[i].contentWindow == window) {
    var el = parent.document.getElementsByTagName('iframe')[i];
    while (el && !el.jswLinkedWindow) el = el.parentElement;
    if (el) jswMainWindow = el.jswLinkedWindow;
   }
  }
  if (document.body) parent.jsw.processSite(document.body, jswMainWindow); else document.addEventListener('DOMContentLoaded', function () { parent.jsw.processSite(document.body, jswMainWindow); }, false);
  return parent.jsw;
 }
 return new JSWSystem();
})();