new (function () {
 var unitObj = jsw.units['adressbar'];

 // initialization
 var query = window.location.href;
 var i = query.indexOf('?');
 if (i == -1) query = '';
 else query = query.substring(i+1, query.length);
 if (window.location.href.indexOf('#') >= 0 && window.location.href.indexOf('#') < i) i = window.location.href.indexOf('#');
 var site = window.location.href.substring(0, i);
 // interpretation des QueryStrings
 if (query != '') if (query.indexOf('jsw&') == 0) { // komplexe Einstellungen im QueryString, Zerlegung erfolgt hier, Ausfuehrung macht recoverWindow
  jsw.enumWindows(function (win) { win.el['OuterBox'].style.visibility = 'hidden'; win.hide(); }); // sichtbare Fenster (wenn moeglich) verstecken
  var w = query.split('&'); // & trennt verschiedene Fenster
  for (var i = 1; i < w.length; i++) {
   var r = new Object();
   w[i] = w[i].split(','); // , trennt verschiedene Typen von Informationen eines Fensters
   for (var j = 0; j < w[i].length; j++) {
    var s = w[i][j].split('='); // = trennt einzelne Informationen eines Typs (erster Parameter ist Typ-Identifier)
    var t = s.shift();
    if (s.length == 0) { s[0] = t; t = 'source'; } // Ausname: Falls kein Typ-Identifier vorhanden, so ist der type 'source'
    switch (t) {
     case 'source' :
      if (s[0].indexOf('$') == 0) r['id'] = s[0].substring(1, s[0].length);
      else r['url'] = decodeURIComponent(s[0]);
      break;
     case 'pos' :
      var p1 = 'top';
      var p2 = 'left';
      var p3 = 'width';
      var p4 = 'height';
      r.pos = { top : Number.NaN, left : Number.NaN, right : Number.NaN, bottom : Number.NaN, width : Number.NaN, height : Number.NaN, position : 'absolute' }
      if (s[4] & 1) r.pos.position = 'fixed';
      if (s[4] & 2) p1 = 'bottom';
      if (s[4] & 4) p4 = 'bottom';
      if (s[4] & 8) p2 = 'right';
      if (s[4] & 16) p3 = 'right';
      r.pos[p1] = s[0];
      r.pos[p2] = s[1];
      r.pos[p3] = s[2];
      r.pos[p4] = s[3];
      if (s[4] & 32) r.pos[p1+'Percent'];
      if (s[4] & 64) r.pos[p2+'Percent'];
      if (s[4] & 128) r.pos[p3+'Percent'];
      if (s[4] & 256) r.pos[p4+'Percent'];
      r.autoHeight = s[4] & 512;
      r.autoWidth = s[4] & 1024;
      break;
     case 'z' :
      r.z = s[0];
      break;
     case 'state' :
      r.maximized = s[0] & 1;
      r.minimized = s[0] & 2;
      r.excluded = s[0] & 4;
      break;
    }
   }
   recoverWindow(r);
  }
 } else jsw.createWindowFromSite(query); // einfache url im QueryString
 
 function recoverWindow (r) {
  if (!r.url && !r.id) return;
  var w;
  if (r.url) {
   var b = jsw.standardBehavoir | 128;
   if (r.maximized) b |= 4;
   if (r.minimized) b |= 64;
   if (r.excluded) b |= 40;
   w = jsw.createWindowFromSite(r.url, b);
   if (w.freed) return; // Fenster hat sich selbst freigegeben
  } else {
   var el = document.getElementById(r.id);
   if (!el || !el.jswLinkedWindow) return;
   w = el.jswLinkedWindow;
   w.recoveryURL = '$'+r.id;
   if (r.maximized) w.maximize();
   if (r.minimized) w.minimize();
   if (r.excluded) w.exclude();
   w.show();
   JSWEffect_terminate(w);
   el.style.visibility = 'visible';
  }
  if (r.pos) {
   w.autoHeight = r.autoHeight;
   w.autoWidth = r.autoWidth;
   w.pos = clone(r.pos);
   w.setPos();
   onshow = function () { w.pos = clone(r.pos); w.setPos(); w.removeEventListener('show', onshow); r = null; }
   w.addEventListener('show', onshow);
  }
  if (r.z) {
   var z = r.z;
   w.addEventListener('show', function (win) { win.setZ(z); });
   window.setTimeout(function () { w.setZ(z); }, 100);
  }
 }
 
 function onURLChange (win) {
  if (jsw.mgr.activeWindow == win) onActivate(win);
 }
 
 function onActivate (win) {
  var u = win.recoveryURL;
  if (!u || !history.replaceState) return;
  var h = getHostnameAndProtocol(window.location.href);
  if (u.indexOf(h) == 0) u = u.substring(h.length, u.length);
  if (u.indexOf('$') == 0) return;
  var stateObj = { foo: "bar" };
  history.replaceState(stateObj, win.title, site + '?' + u);
 }
 
 jsw.mgr.addEventListener('activate', onActivate);
 jsw.mgr.addEventListener('recoveryURLChanged', onURLChange);
 
 this.free = function () {
  jsw.mgr.removeEventListener('activate', onActivate);
  for (var key in this) if (typeof this[key] == 'object') this[key] = null;
 }
 
 // unit loaded
 unitObj.unit = this;
 unitObj.onload();
})();