new (function () {
 var unitObj = jsw.units['switchableDesign'];
 var eventListeners = new Array();
 var currentFiles = null;
 this.designInfo = new Object();
 
 var fileName = function (path) {
  var p = path.split('\/');
  return p[p.length-1].split('.')[0];
 }
 
 var actualizeDesign = function (doc) {
  for (var key in currentFiles) currentFiles[key].set = false;
  // Designsettings aus Seite loeschen
  var settings = doc.getElementById('JSWDesignSettings');
  if (settings) settings.parentElement.removeChild(settings);
  else { settings = doc.createElement('style'); settings.type = 'text/css'; settings.id = 'JSWDesignSettings'; }
  settings.innerHTML = '';
  // Files, die bereits in Seite geladen sind, durch neues Design ersetzen, falls diese im Design existieren oder loeschen, falls nicht
  var nodes = doc.getElementsByTagName('link');
  for (var i = nodes.length-1; i >= 0; i--) {
   if ((' '+nodes[i].className+' ').indexOf(' design ') == -1 && (' '+nodes[i].className+' ').indexOf(' JSW ') == -1) continue; // Stylesheets, die nicht zum Design gehoeren unveraendert lassen
   var f = currentFiles[fileName(nodes[i].href)];
   if (!f) nodes[i].parentElement.removeChild(nodes[i]);
   else {
    nodes[i].href = f.url;
    if (f.settingsClass) {
     settings.innerHTML += '.' + f.settingsClass + ' {\n';
     settings.innerHTML += f.settings;
     settings.innerHTML += '}\n';
    } else settings.innerHTML += f.settings;
    f.set = true;
   }
  }
  nodes = null;
  // Files, die nicht in Seite geladen sind, aber gemaess Flags benoetigt werden, einfuegen
  for (var key in currentFiles) if ((!currentFiles[key].set) && (((doc == document) && (currentFiles[key].flags & 1)) || ((doc != document) && (currentFiles[key].flags & 2)))) {
   var newFile = doc.createElement('link');
   newFile.rel = 'stylesheet';
   newFile.className = 'JSW design';
   newFile.href = currentFiles[key].url;
   doc.getElementsByTagName('head')[0].appendChild(newFile);
   if (currentFiles[key].settingsClass) {
    settings.innerHTML += '.' + currentFiles[key].settingsClass + ' {\n';
    settings.innerHTML += currentFiles[key].settings;
    settings.innerHTML += '}\n';
   } else settings.innerHTML += currentFiles[key].settings;
  }
  // Benoetigte CSS-Settings einfuegen
  doc.getElementsByTagName('head')[0].appendChild(settings);
 }
 
 this.loadDesign = function (name) {
  if (!name) for (var key in this.designInfo) if (this.designInfo[key].isDefault) { name = key; break; }
  if (!this.designInfo[name]) throw 'The Design "' + name + '" is unknown!';
  currentFiles = new Object();
  for (var i = 0; i < this.designInfo[name].files.length; i++) currentFiles[fileName(this.designInfo[name].files[i].url)] = clone(this.designInfo[name].files[i]);
  actualizeDesign(window.document);
  jsw.enumWindows(function (win) { try { if (win.mainFrame.contentWindow.document) actualizeDesign(win.mainFrame.contentWindow.document); } catch (e) {} });
  if (jsw.units.effects) jsw.units.effects.forceUnload();
  if (this.designInfo[name].script) jsw.dynamicallyLoadUnit(this.designInfo[name].script, null);
 }
 
 this.requireDesignFile = function (fName, el) {
  var doc = el.ownerDocument;
  if (!doc) throw 'Element for requireDesignFile must be inserted into the DOM';
  // falls fName bereits geladen wurde, abbrechen
  var nodes = doc.getElementsByTagName('link');
  for (var i = 0; i < nodes.length; i++) if (fileName(nodes[i].href) == fName) return;
  nodes = null;
  // falls im Design vorhanden, neues File laden
  if (!currentFiles[fName]) return;
  var newFile = doc.createElement('link');
  newFile.rel = 'stylesheet';
  newFile.className = 'JSW design';
  newFile.href = currentFiles[fName].url;
  doc.getElementsByTagName('head')[0].appendChild(newFile);
  // Benoetigte CSS-Settings einfuegen
  var settings = doc.getElementById('JSWDesignSettings');
  if (settings) if (currentFiles[fName].settingsClass) {
   settings.innerHTML += '.' + currentFiles[fName].settingsClass + ' {\n';
   settings.innerHTML += currentFiles[fName].settings;
   settings.innerHTML += '}\n';
  } else settings.innerHTML += currentFiles[fName].settings;
 }
 
 var doShow = function (win) {
  var nr = 0;
  while (nr < eventListeners.length && eventListeners[nr] != null) nr++;
  eventListeners[nr] = new Array();
  function modifyFrame (frame) {
   var ev = new Object();
   eventListeners[nr].push(ev);
   ev.el = frame;
   ev.fkt = function () {
    try {
     for (var i = 0; i < ev.el.contentWindow.document.getElementsByTagName('iframe').length; i++) modifyFrame(ev.el.contentWindow.document.getElementsByTagName('iframe')[i]);
     actualizeDesign(ev.el.contentWindow.document);
    } catch (e) {}
   }
   ev.el.addEventListener('load', ev.fkt, false);
   ev.fkt();
  }
  var f = win.el.InnerBox.getElementsByTagName('iframe');
  for (var i = 0; i < f.length; i++) modifyFrame(f[i]);
  function rmListener () {
   if (nr < 0) return;
   for (var i = 0; i < eventListeners[nr].length; i++) try { eventListeners[nr][i].el.removeEventListener('load', eventListeners[nr][i].fkt); } catch (e) {};
   eventListeners[nr] = null;
   nr = -1;
  }
  win.addEventListener('hide', rmListener);
  win.addEventListener('free', rmListener);
 }
 
 this.addDesignInfoFromFile = function (path, callback) {
  var frame = document.createElement('iframe');
  frame.style.height = '0px';
  frame.style.border = '0px none transparent';
  var _this = this;
  frame.onload = function () {
   var di;
   eval('di = ' + frame.contentWindow.document.body.innerHTML + ';');
   for (var key in di) {
    _this.designInfo[key] = di[key];
    if (_this.designInfo[key].url) _this.designInfo[key].url = absolutePath(di[key].url, frame.src);
    if (_this.designInfo[key].script) _this.designInfo[key].script = absolutePath(di[key].script, frame.src);
    for (var i = 0; i < di[key].files.length; i++) _this.designInfo[key].files[i].url = absolutePath(di[key].files[i].url, frame.src);
   }
   di = null;
   document.body.removeChild(frame);
   if (callback) callback();
  }
  document.body.appendChild(frame);
  frame.src = path;
 }

 this.free = function () {
  currentFiles = null;
  jsw.mgr.removeEventListener('show', doShow);
  for (i = 0; i < eventListeners.length; i++) if (eventListeners[i] != null) for (var i = 0; i < eventListeners[i].length; i++) try { eventListeners[i][i].el.removeEventListener('load', eventListeners[i][i].fkt); } catch (e) {};
  for (var key in this) if (typeof this[key] == 'object') this[key] = null;
 }
 
 // initialization 
 jsw.mgr.addEventListener('show', doShow);

 // unit loaded
 unitObj.unit = this;
 unitObj.onload();
})();